Attribute VB_Name = "WinAMP_Control"
Option Explicit

''''''''''''''''''''''''''''''''''''''''
' Duane Odom  4/12/2000                '
'--------------------------------------'
' This code is provided as is with no  '
' warranty or guarantees of any kind.  '
'--------------------------------------'
'                                      '
'   PLEASE DO NOT REMOVE THIS HEADER   '
'                                      '
''''''''''''''''''''''''''''''''''''''''


'--------------------------------------'
'           Global Variables           '
'--------------------------------------'
Public hWndWinAMP As Long

'--------------------------------------'
'              Constants               '
'--------------------------------------'

'This constant must be changed to point to the path of your WinAMP executable.
'This could be made easier by finding it with code, but that was too slow for my
'particular project.
Public Const WINAMP_PATH As String = "C:\Program Files\Winamp\winamp.exe"

Public Const WM_COMMAND = &H111                     'Used in SendMessage call
Public Const WM_USER = &H400                        'Used in SendMessage call
Public Const vbQuote As String = """"               'Used in shelling to WinAMP

'--------------------------------------'
'      Command Message Constants       '
'--------------------------------------'
Public Const WA_PREVTRACK = 40044
Public Const WA_NEXTTRACK = 40048
Public Const WA_PLAY = 40045
Public Const WA_PAUSE = 40046
Public Const WA_STOP = 40047
Public Const WA_FADEOUTSTOP = 40147
Public Const WA_STOPAFTERTRACK = 40157
Public Const WA_FASTFORWARD = 40148                 '5 secs
Public Const WA_FASTREWIND = 40144                  '5 secs
Public Const WA_PLAYLISTHOME = 40154
Public Const WA_PLAYLISTEND = 40158
Public Const WA_DIALOGOPENFILE = 40029
Public Const WA_DIALOGOPENURL = 40155
Public Const WA_DIALOGFILEINFO = 40188
Public Const WA_TIMEDISPLAYELAPSED = 40037
Public Const WA_TIMEDISPLAYREMAINING = 40038
Public Const WA_TOGGLEPREFERENCES = 40012
Public Const WA_DIALOGVISUALOPTIONS = 40190
Public Const WA_DIALOGVISUALPLUGINOPTIONS = 40191
Public Const WA_STARTVISUALPLUGIN = 40192
Public Const WA_TOGGLEABOUT = 40041
Public Const WA_TOGGLEAUTOSCROLL = 40189
Public Const WA_TOGGLEALWAYSONTOP = 40019
Public Const WA_TOGGLEWINDOWSHADE = 40064
Public Const WA_TOGGLEPLAYLISTWINDOWSHADE = 40266
Public Const WA_TOGGLEDOUBLESIZE = 40165
Public Const WA_TOGGLEEQ = 40036
Public Const WA_TOGGLEPLAYLIST = 40040
Public Const WA_TOGGLEMAINWINDOW = 40258
Public Const WA_TOGGLEMINIBROWSER = 40298
Public Const WA_TOGGLEEASYMOVE = 40186
Public Const WA_VOLUMEUP = 40058                    'increase 1%
Public Const WA_VOLUMEDOWN = 40059                  'decrease 1%
Public Const WA_TOGGLEREPEAT = 40022
Public Const WA_TOGGLESHUFFLE = 40023
Public Const WA_DIALOGJUMPTOTIME = 40193
Public Const WA_DIALOGJUMPTOFILE = 40194
Public Const WA_DIALOGSKINSELECTOR = 40219
Public Const WA_DIALOGCONFIGUREVISUALPLUGIN = 40221
Public Const WA_RELOADSKIN = 40291
Public Const WA_CLOSE = 40001

'--------------------------------------'
'         User Message Constants       '
'--------------------------------------'
Public Const WA_GETVERSION = 0
Public Const WA_CLEARPLAYLIST = 101
Public Const WA_GETSTATUS = 104
Public Const WA_GETTRACKPOSITION = 105
Public Const WA_GETTRACKLENGTH = 105
Public Const WA_SEEKTOPOSITION = 106
Public Const WA_SETVOLUME = 122
Public Const WA_SETBALANCE = 123
Public Const WA_GETEQDATA = 127
Public Const WA_SETEQDATA = 128


'--------------------------------------'
'       Windows API Declarations       '
'--------------------------------------'
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Function FileExists(ByVal Filename As String) As Boolean
    
    Dim FileInfo As Variant

    'Set Default
    FileExists = True
    
    'Set up error handler
    On Error Resume Next

    'Attempt to grab date and time
    FileInfo = FileDateTime(Filename)

    'Process errors
    Select Case Err
        Case 53, 76, 68   'File Does Not Exist
            FileExists = False
            Err = 0
        Case Else
            If Err <> 0 Then
                MsgBox "Error Number: " & Err & Chr$(10) & Chr$(13) & " " & Error, vbOKOnly, "Error"
                End
            End If
    End Select
    
End Function
Sub WinAMP_SetEQValue(EQ_Index As Long, EQ_Value As Long)
    
    '-------------------------------------------------------------'
    'Sets the EQ slider value for the slider specified by EQ_Index'
    '-------------------------------------------------------------'
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If
    
    'eq values will range from 0(top) to 63(bottom)
    
    'range check the EQ Index
    If EQ_Index < 0 Or EQ_Index > 9 Then Exit Sub
    
    'range check the new EQ value
    If EQ_Value < 0 Or EQ_Value > 63 Then Exit Sub
    
    'we have to query the eq line we want to change first
    SendMessage hWndWinAMP, WM_USER, EQ_Index, WA_GETEQDATA
    
    'now we send the new eq value to the selected eq line
    SendMessage hWndWinAMP, WM_USER, EQ_Value, WA_SETEQDATA

End Sub
Sub WinAMP_SetPreAmpValue(PreAmp_Value As Long)
    
    '----------------------'
    'Sets the Pre-amp value'
    '----------------------'
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If
    
    'pre-amp values will range from 0(top) to 63(bottom)
    
    'range check the new pre-amp value
    If PreAmp_Value < 0 Or PreAmp_Value > 63 Then Exit Sub
    
    'we have to query the pre-amp first
    SendMessage hWndWinAMP, WM_USER, 10, WA_GETEQDATA
    
    'now we send the new pre-amp value
    SendMessage hWndWinAMP, WM_USER, PreAmp_Value, WA_SETEQDATA

End Sub
Sub WinAMP_ClearPlaylist()
    
    '------------------------'
    'Clears WinAMP's playlist'
    '------------------------'
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If

    SendMessage hWndWinAMP, WM_USER, 0, WA_CLEARPLAYLIST

End Sub


Function WinAMP_FindWindow() As Boolean

    '-------------------------------------'
    'Retrieves a handle to WinAMP's window'
    '-------------------------------------'

    hWndWinAMP = FindWindow("Winamp v1.x", vbNullString)
    
    If hWndWinAMP <> 0 Then
       WinAMP_FindWindow = True
    Else
       WinAMP_FindWindow = False
    End If

End Function


Function WinAMP_GetStatus() As String

    '----------------------------------------------------------'
    'Retrieves the status of WinAMP: PLAYING, PAUSED or STOPPED'
    '----------------------------------------------------------'

    Dim Status As Long
    Dim i As Long

    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If

    Status = SendMessage(hWndWinAMP, WM_USER, 0, WA_GETSTATUS)
    
    Select Case Status
       Case 1
          WinAMP_GetStatus = "PLAYING"
       Case 3
          WinAMP_GetStatus = "PAUSED"
       Case Else
          WinAMP_GetStatus = "STOPPED"
    End Select

End Function

Function WinAMP_GetTrackPosition() As Long

    '---------------------------------------------------'
    'Retrieves the position of the current track in secs'
    '---------------------------------------------------'

    Dim ReturnPos As Long
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If

    'ReturnPos will contain the current track pos in milliseconds
    'or -1 if no track is playing or an error occurs
    ReturnPos = SendMessage(hWndWinAMP, WM_USER, 0, WA_GETTRACKPOSITION)

    If ReturnPos <> -1 Then
       WinAMP_GetTrackPosition = ReturnPos \ 1000   'convert ReturnPos to secs
    Else
       WinAMP_GetTrackPosition = -1
    End If

End Function

Function WinAMP_GetEQValue(EQ_Index As Long) As Long

    '------------------------------------------------------------------'
    'Retrieves the EQ slider value for the slider specified by EQ_Index'
    '------------------------------------------------------------------'

    Dim ReturnValue As Long
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If
    
    'range check the EQ Index (between 0 and 9, inclusive)
    If EQ_Index < 0 Or EQ_Index > 9 Then
       WinAMP_GetEQValue = -1
       Exit Function
    End If
    
    'return value will hold a value for the selected EQ slider
    'values will range from 0(top) to 63(bottom)
    ReturnValue = SendMessage(hWndWinAMP, WM_USER, EQ_Index, WA_GETEQDATA)

    WinAMP_GetEQValue = ReturnValue

End Function
Function WinAMP_GetPreAmpValue() As Long

    '----------------------------------'
    'Retrieves the Pre-amp slider value'
    '----------------------------------'

    Dim ReturnValue As Long
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If
    
    'values will range from 0(top) to 63(bottom)
    ReturnValue = SendMessage(hWndWinAMP, WM_USER, 10, WA_GETEQDATA)

    WinAMP_GetPreAmpValue = ReturnValue

End Function
Sub WinAMP_SeekToPosition(PositionInSec As Long)

    '----------------------------------------------------'
    'Seeks to the specified position in the current track'
    '----------------------------------------------------'

    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If

    'range check the new position
    If PositionInSec < 0 Or PositionInSec > WinAMP_GetTrackLength Then
       Exit Sub
    End If

    SendMessage hWndWinAMP, WM_USER, CLng(PositionInSec * 1000), WA_SEEKTOPOSITION

End Sub
Sub WinAMP_SetVolume(VolumeValue As Long)

    '----------------------'
    'Sets the volume slider'
    '----------------------'

    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If

    'volume values will range from 0(bottom) to 255(top)

    'range check the new volume
    If VolumeValue < 0 Or VolumeValue > 255 Then
       Exit Sub
    End If

    SendMessage hWndWinAMP, WM_USER, VolumeValue, WA_SETVOLUME

End Sub

Sub WinAMP_SetBalance(BalanceValue As Long)

    '-----------------------'
    'Sets the Balance slider'
    '-----------------------'

    Dim ScaledBalanceValue As Long

    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If

    'we want the range of balance to be from -127 to 127, but the
    'real range is as follows
    
    '|LEFT                       CENTER                       RIGHT|
    '|128 ----------------------255(or 0)-----------------------127|
    '|_____________________________________________________________|
    
    'range check the new balance
    If BalanceValue < -127 Or BalanceValue > 127 Then
       Exit Sub
    End If
    
    'here we do our shifting to correct the range of values
    If BalanceValue < 0 Then
       ScaledBalanceValue = 255 + BalanceValue
    Else
       ScaledBalanceValue = BalanceValue
    End If

    SendMessage hWndWinAMP, WM_USER, ScaledBalanceValue, WA_SETBALANCE

End Sub
Function WinAMP_GetTrackLength() As Long

    '-------------------------------------------------'
    'Retrieves the length of the current track in secs'
    '-------------------------------------------------'

    Dim ReturnLength As Long
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If

    'ReturnLength will contain the current track length in seconds
    'or -1 if no track is playing or an error occurs
    ReturnLength = SendMessage(hWndWinAMP, WM_USER, 1, WA_GETTRACKLENGTH)

    If ReturnLength <> -1 Then
       WinAMP_GetTrackLength = ReturnLength
    Else
       WinAMP_GetTrackLength = -1
    End If

End Function

Function WinAMP_GetVersion() As String

    '---------------------------------------'
    'Retrieves the version of WinAMP running'
    '---------------------------------------'

    Dim VersionNum As Long
    Dim ReturnVersion As String

    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Function
    End If

    VersionNum = SendMessage(hWndWinAMP, WM_USER, 0, WA_GETVERSION)
    
    If Len(Hex(VersionNum)) > 3 Then
       ReturnVersion = Left(Hex(VersionNum), 1) & "."
       ReturnVersion = ReturnVersion & Mid(Hex(VersionNum), 2, 1)
       ReturnVersion = ReturnVersion & Right$(Hex(VersionNum), Len(Hex(VersionNum)) - 3)
       WinAMP_GetVersion = ReturnVersion
    Else
       WinAMP_GetVersion = "UNKNOWN"
    End If

End Function

Sub WinAMP_SendCommandMessage(CommandMessage As Long)
    
    '--------------------------------------------------'
    'Used to send any of the Command messages to WinAMP'
    '--------------------------------------------------'
    
    If hWndWinAMP = 0 Then
       MsgBox "WinAMP window not found yet...", vbOKOnly + vbCritical, "WinAMP Not Found"
       Exit Sub
    End If
    
    SendMessage hWndWinAMP, WM_COMMAND, CommandMessage, 0

End Sub


Public Function WinAMP_Start() As Boolean

    '---------------------------------------------------------------'
    'Runs an instance of WinAMP if an instance isn't already running'
    '---------------------------------------------------------------'

    Dim ReturnValue As Double
    
    ReturnValue = Shell(WINAMP_PATH, vbMinimizedNoFocus)
    
    If ReturnValue <> 0 Then
       WinAMP_Start = True
    Else
       WinAMP_Start = False
    End If

End Function


Public Function WinAMP_OpenFile(strFilename As String) As Boolean

    '----------------------------------------------------'
    'Causes WinAMP to open the file specified by filename'
    '----------------------------------------------------'

    Dim ReturnValue As Double
    
    If FileExists(strFilename) Then
       ReturnValue = Shell(WINAMP_PATH & " /ADD " & vbQuote & strFilename & vbQuote, vbMinimizedNoFocus)
    
       If ReturnValue <> 0 Then
          WinAMP_OpenFile = True
       Else
          WinAMP_OpenFile = False
       End If
    Else
       WinAMP_OpenFile = False
    End If

End Function
